# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20201101


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class CloudAsmInstanceSummary(object):
    """
    The summary of a cloud ASM instance.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new CloudAsmInstanceSummary object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param id:
            The value to assign to the id property of this CloudAsmInstanceSummary.
        :type id: str

        :param dbaas_id:
            The value to assign to the dbaas_id property of this CloudAsmInstanceSummary.
        :type dbaas_id: str

        :param display_name:
            The value to assign to the display_name property of this CloudAsmInstanceSummary.
        :type display_name: str

        :param component_name:
            The value to assign to the component_name property of this CloudAsmInstanceSummary.
        :type component_name: str

        :param compartment_id:
            The value to assign to the compartment_id property of this CloudAsmInstanceSummary.
        :type compartment_id: str

        :param cloud_asm_id:
            The value to assign to the cloud_asm_id property of this CloudAsmInstanceSummary.
        :type cloud_asm_id: str

        :param cloud_db_system_id:
            The value to assign to the cloud_db_system_id property of this CloudAsmInstanceSummary.
        :type cloud_db_system_id: str

        :param cloud_db_node_id:
            The value to assign to the cloud_db_node_id property of this CloudAsmInstanceSummary.
        :type cloud_db_node_id: str

        :param adr_home_directory:
            The value to assign to the adr_home_directory property of this CloudAsmInstanceSummary.
        :type adr_home_directory: str

        :param host_name:
            The value to assign to the host_name property of this CloudAsmInstanceSummary.
        :type host_name: str

        :param lifecycle_state:
            The value to assign to the lifecycle_state property of this CloudAsmInstanceSummary.
        :type lifecycle_state: str

        :param lifecycle_details:
            The value to assign to the lifecycle_details property of this CloudAsmInstanceSummary.
        :type lifecycle_details: str

        :param time_created:
            The value to assign to the time_created property of this CloudAsmInstanceSummary.
        :type time_created: datetime

        :param time_updated:
            The value to assign to the time_updated property of this CloudAsmInstanceSummary.
        :type time_updated: datetime

        :param freeform_tags:
            The value to assign to the freeform_tags property of this CloudAsmInstanceSummary.
        :type freeform_tags: dict(str, str)

        :param defined_tags:
            The value to assign to the defined_tags property of this CloudAsmInstanceSummary.
        :type defined_tags: dict(str, dict(str, object))

        :param system_tags:
            The value to assign to the system_tags property of this CloudAsmInstanceSummary.
        :type system_tags: dict(str, dict(str, object))

        """
        self.swagger_types = {
            'id': 'str',
            'dbaas_id': 'str',
            'display_name': 'str',
            'component_name': 'str',
            'compartment_id': 'str',
            'cloud_asm_id': 'str',
            'cloud_db_system_id': 'str',
            'cloud_db_node_id': 'str',
            'adr_home_directory': 'str',
            'host_name': 'str',
            'lifecycle_state': 'str',
            'lifecycle_details': 'str',
            'time_created': 'datetime',
            'time_updated': 'datetime',
            'freeform_tags': 'dict(str, str)',
            'defined_tags': 'dict(str, dict(str, object))',
            'system_tags': 'dict(str, dict(str, object))'
        }
        self.attribute_map = {
            'id': 'id',
            'dbaas_id': 'dbaasId',
            'display_name': 'displayName',
            'component_name': 'componentName',
            'compartment_id': 'compartmentId',
            'cloud_asm_id': 'cloudAsmId',
            'cloud_db_system_id': 'cloudDbSystemId',
            'cloud_db_node_id': 'cloudDbNodeId',
            'adr_home_directory': 'adrHomeDirectory',
            'host_name': 'hostName',
            'lifecycle_state': 'lifecycleState',
            'lifecycle_details': 'lifecycleDetails',
            'time_created': 'timeCreated',
            'time_updated': 'timeUpdated',
            'freeform_tags': 'freeformTags',
            'defined_tags': 'definedTags',
            'system_tags': 'systemTags'
        }
        self._id = None
        self._dbaas_id = None
        self._display_name = None
        self._component_name = None
        self._compartment_id = None
        self._cloud_asm_id = None
        self._cloud_db_system_id = None
        self._cloud_db_node_id = None
        self._adr_home_directory = None
        self._host_name = None
        self._lifecycle_state = None
        self._lifecycle_details = None
        self._time_created = None
        self._time_updated = None
        self._freeform_tags = None
        self._defined_tags = None
        self._system_tags = None

    @property
    def id(self):
        """
        **[Required]** Gets the id of this CloudAsmInstanceSummary.
        The `OCID`__ of the cloud ASM instance.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The id of this CloudAsmInstanceSummary.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this CloudAsmInstanceSummary.
        The `OCID`__ of the cloud ASM instance.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param id: The id of this CloudAsmInstanceSummary.
        :type: str
        """
        self._id = id

    @property
    def dbaas_id(self):
        """
        Gets the dbaas_id of this CloudAsmInstanceSummary.
        The `OCID`__ in DBaas service.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The dbaas_id of this CloudAsmInstanceSummary.
        :rtype: str
        """
        return self._dbaas_id

    @dbaas_id.setter
    def dbaas_id(self, dbaas_id):
        """
        Sets the dbaas_id of this CloudAsmInstanceSummary.
        The `OCID`__ in DBaas service.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param dbaas_id: The dbaas_id of this CloudAsmInstanceSummary.
        :type: str
        """
        self._dbaas_id = dbaas_id

    @property
    def display_name(self):
        """
        **[Required]** Gets the display_name of this CloudAsmInstanceSummary.
        The user-friendly name for the ASM instance. The name does not have to be unique.


        :return: The display_name of this CloudAsmInstanceSummary.
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """
        Sets the display_name of this CloudAsmInstanceSummary.
        The user-friendly name for the ASM instance. The name does not have to be unique.


        :param display_name: The display_name of this CloudAsmInstanceSummary.
        :type: str
        """
        self._display_name = display_name

    @property
    def component_name(self):
        """
        **[Required]** Gets the component_name of this CloudAsmInstanceSummary.
        The name of the cloud ASM instance.


        :return: The component_name of this CloudAsmInstanceSummary.
        :rtype: str
        """
        return self._component_name

    @component_name.setter
    def component_name(self, component_name):
        """
        Sets the component_name of this CloudAsmInstanceSummary.
        The name of the cloud ASM instance.


        :param component_name: The component_name of this CloudAsmInstanceSummary.
        :type: str
        """
        self._component_name = component_name

    @property
    def compartment_id(self):
        """
        **[Required]** Gets the compartment_id of this CloudAsmInstanceSummary.
        The `OCID`__ of the compartment.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The compartment_id of this CloudAsmInstanceSummary.
        :rtype: str
        """
        return self._compartment_id

    @compartment_id.setter
    def compartment_id(self, compartment_id):
        """
        Sets the compartment_id of this CloudAsmInstanceSummary.
        The `OCID`__ of the compartment.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param compartment_id: The compartment_id of this CloudAsmInstanceSummary.
        :type: str
        """
        self._compartment_id = compartment_id

    @property
    def cloud_asm_id(self):
        """
        **[Required]** Gets the cloud_asm_id of this CloudAsmInstanceSummary.
        The `OCID`__ of the cloud ASM that the ASM instance belongs to.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The cloud_asm_id of this CloudAsmInstanceSummary.
        :rtype: str
        """
        return self._cloud_asm_id

    @cloud_asm_id.setter
    def cloud_asm_id(self, cloud_asm_id):
        """
        Sets the cloud_asm_id of this CloudAsmInstanceSummary.
        The `OCID`__ of the cloud ASM that the ASM instance belongs to.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param cloud_asm_id: The cloud_asm_id of this CloudAsmInstanceSummary.
        :type: str
        """
        self._cloud_asm_id = cloud_asm_id

    @property
    def cloud_db_system_id(self):
        """
        **[Required]** Gets the cloud_db_system_id of this CloudAsmInstanceSummary.
        The `OCID`__ of the cloud DB system that the ASM instance is a part of.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The cloud_db_system_id of this CloudAsmInstanceSummary.
        :rtype: str
        """
        return self._cloud_db_system_id

    @cloud_db_system_id.setter
    def cloud_db_system_id(self, cloud_db_system_id):
        """
        Sets the cloud_db_system_id of this CloudAsmInstanceSummary.
        The `OCID`__ of the cloud DB system that the ASM instance is a part of.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param cloud_db_system_id: The cloud_db_system_id of this CloudAsmInstanceSummary.
        :type: str
        """
        self._cloud_db_system_id = cloud_db_system_id

    @property
    def cloud_db_node_id(self):
        """
        Gets the cloud_db_node_id of this CloudAsmInstanceSummary.
        The `OCID`__ of the cloud DB node on which the ASM instance is running.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The cloud_db_node_id of this CloudAsmInstanceSummary.
        :rtype: str
        """
        return self._cloud_db_node_id

    @cloud_db_node_id.setter
    def cloud_db_node_id(self, cloud_db_node_id):
        """
        Sets the cloud_db_node_id of this CloudAsmInstanceSummary.
        The `OCID`__ of the cloud DB node on which the ASM instance is running.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param cloud_db_node_id: The cloud_db_node_id of this CloudAsmInstanceSummary.
        :type: str
        """
        self._cloud_db_node_id = cloud_db_node_id

    @property
    def adr_home_directory(self):
        """
        Gets the adr_home_directory of this CloudAsmInstanceSummary.
        The Automatic Diagnostic Repository (ADR) home directory for the ASM instance.


        :return: The adr_home_directory of this CloudAsmInstanceSummary.
        :rtype: str
        """
        return self._adr_home_directory

    @adr_home_directory.setter
    def adr_home_directory(self, adr_home_directory):
        """
        Sets the adr_home_directory of this CloudAsmInstanceSummary.
        The Automatic Diagnostic Repository (ADR) home directory for the ASM instance.


        :param adr_home_directory: The adr_home_directory of this CloudAsmInstanceSummary.
        :type: str
        """
        self._adr_home_directory = adr_home_directory

    @property
    def host_name(self):
        """
        Gets the host_name of this CloudAsmInstanceSummary.
        The name of the host on which the ASM instance is running.


        :return: The host_name of this CloudAsmInstanceSummary.
        :rtype: str
        """
        return self._host_name

    @host_name.setter
    def host_name(self, host_name):
        """
        Sets the host_name of this CloudAsmInstanceSummary.
        The name of the host on which the ASM instance is running.


        :param host_name: The host_name of this CloudAsmInstanceSummary.
        :type: str
        """
        self._host_name = host_name

    @property
    def lifecycle_state(self):
        """
        **[Required]** Gets the lifecycle_state of this CloudAsmInstanceSummary.
        The current lifecycle state of the cloud ASM instance.


        :return: The lifecycle_state of this CloudAsmInstanceSummary.
        :rtype: str
        """
        return self._lifecycle_state

    @lifecycle_state.setter
    def lifecycle_state(self, lifecycle_state):
        """
        Sets the lifecycle_state of this CloudAsmInstanceSummary.
        The current lifecycle state of the cloud ASM instance.


        :param lifecycle_state: The lifecycle_state of this CloudAsmInstanceSummary.
        :type: str
        """
        self._lifecycle_state = lifecycle_state

    @property
    def lifecycle_details(self):
        """
        Gets the lifecycle_details of this CloudAsmInstanceSummary.
        Additional information about the current lifecycle state.


        :return: The lifecycle_details of this CloudAsmInstanceSummary.
        :rtype: str
        """
        return self._lifecycle_details

    @lifecycle_details.setter
    def lifecycle_details(self, lifecycle_details):
        """
        Sets the lifecycle_details of this CloudAsmInstanceSummary.
        Additional information about the current lifecycle state.


        :param lifecycle_details: The lifecycle_details of this CloudAsmInstanceSummary.
        :type: str
        """
        self._lifecycle_details = lifecycle_details

    @property
    def time_created(self):
        """
        Gets the time_created of this CloudAsmInstanceSummary.
        The date and time the cloud ASM instance was created.


        :return: The time_created of this CloudAsmInstanceSummary.
        :rtype: datetime
        """
        return self._time_created

    @time_created.setter
    def time_created(self, time_created):
        """
        Sets the time_created of this CloudAsmInstanceSummary.
        The date and time the cloud ASM instance was created.


        :param time_created: The time_created of this CloudAsmInstanceSummary.
        :type: datetime
        """
        self._time_created = time_created

    @property
    def time_updated(self):
        """
        Gets the time_updated of this CloudAsmInstanceSummary.
        The date and time the cloud ASM instance was last updated.


        :return: The time_updated of this CloudAsmInstanceSummary.
        :rtype: datetime
        """
        return self._time_updated

    @time_updated.setter
    def time_updated(self, time_updated):
        """
        Sets the time_updated of this CloudAsmInstanceSummary.
        The date and time the cloud ASM instance was last updated.


        :param time_updated: The time_updated of this CloudAsmInstanceSummary.
        :type: datetime
        """
        self._time_updated = time_updated

    @property
    def freeform_tags(self):
        """
        Gets the freeform_tags of this CloudAsmInstanceSummary.
        Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace.
        For more information, see `Resource Tags`__.
        Example: `{\"Department\": \"Finance\"}`

        __ https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm


        :return: The freeform_tags of this CloudAsmInstanceSummary.
        :rtype: dict(str, str)
        """
        return self._freeform_tags

    @freeform_tags.setter
    def freeform_tags(self, freeform_tags):
        """
        Sets the freeform_tags of this CloudAsmInstanceSummary.
        Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace.
        For more information, see `Resource Tags`__.
        Example: `{\"Department\": \"Finance\"}`

        __ https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm


        :param freeform_tags: The freeform_tags of this CloudAsmInstanceSummary.
        :type: dict(str, str)
        """
        self._freeform_tags = freeform_tags

    @property
    def defined_tags(self):
        """
        Gets the defined_tags of this CloudAsmInstanceSummary.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        For more information, see `Resource Tags`__.
        Example: `{\"Operations\": {\"CostCenter\": \"42\"}}`

        __ https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm


        :return: The defined_tags of this CloudAsmInstanceSummary.
        :rtype: dict(str, dict(str, object))
        """
        return self._defined_tags

    @defined_tags.setter
    def defined_tags(self, defined_tags):
        """
        Sets the defined_tags of this CloudAsmInstanceSummary.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        For more information, see `Resource Tags`__.
        Example: `{\"Operations\": {\"CostCenter\": \"42\"}}`

        __ https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm


        :param defined_tags: The defined_tags of this CloudAsmInstanceSummary.
        :type: dict(str, dict(str, object))
        """
        self._defined_tags = defined_tags

    @property
    def system_tags(self):
        """
        Gets the system_tags of this CloudAsmInstanceSummary.
        System tags for this resource. Each key is predefined and scoped to a namespace.
        For more information, see `Resource Tags`__.
        System tags can be viewed by users, but can only be created by the system.

        Example: `{\"orcl-cloud\": {\"free-tier-retained\": \"true\"}}`

        __ https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm


        :return: The system_tags of this CloudAsmInstanceSummary.
        :rtype: dict(str, dict(str, object))
        """
        return self._system_tags

    @system_tags.setter
    def system_tags(self, system_tags):
        """
        Sets the system_tags of this CloudAsmInstanceSummary.
        System tags for this resource. Each key is predefined and scoped to a namespace.
        For more information, see `Resource Tags`__.
        System tags can be viewed by users, but can only be created by the system.

        Example: `{\"orcl-cloud\": {\"free-tier-retained\": \"true\"}}`

        __ https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm


        :param system_tags: The system_tags of this CloudAsmInstanceSummary.
        :type: dict(str, dict(str, object))
        """
        self._system_tags = system_tags

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
