# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20241201


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class ShapeMemoryOptions(object):
    """
    Options for the the shape memory
    """

    def __init__(self, **kwargs):
        """
        Initializes a new ShapeMemoryOptions object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param min_in_gbs:
            The value to assign to the min_in_gbs property of this ShapeMemoryOptions.
        :type min_in_gbs: float

        :param max_in_gbs:
            The value to assign to the max_in_gbs property of this ShapeMemoryOptions.
        :type max_in_gbs: float

        """
        self.swagger_types = {
            'min_in_gbs': 'float',
            'max_in_gbs': 'float'
        }
        self.attribute_map = {
            'min_in_gbs': 'minInGBs',
            'max_in_gbs': 'maxInGBs'
        }
        self._min_in_gbs = None
        self._max_in_gbs = None

    @property
    def min_in_gbs(self):
        """
        **[Required]** Gets the min_in_gbs of this ShapeMemoryOptions.
        Minimum Memory configuration in GBs


        :return: The min_in_gbs of this ShapeMemoryOptions.
        :rtype: float
        """
        return self._min_in_gbs

    @min_in_gbs.setter
    def min_in_gbs(self, min_in_gbs):
        """
        Sets the min_in_gbs of this ShapeMemoryOptions.
        Minimum Memory configuration in GBs


        :param min_in_gbs: The min_in_gbs of this ShapeMemoryOptions.
        :type: float
        """
        self._min_in_gbs = min_in_gbs

    @property
    def max_in_gbs(self):
        """
        **[Required]** Gets the max_in_gbs of this ShapeMemoryOptions.
        Maximum Memory configuration in GBs


        :return: The max_in_gbs of this ShapeMemoryOptions.
        :rtype: float
        """
        return self._max_in_gbs

    @max_in_gbs.setter
    def max_in_gbs(self, max_in_gbs):
        """
        Sets the max_in_gbs of this ShapeMemoryOptions.
        Maximum Memory configuration in GBs


        :param max_in_gbs: The max_in_gbs of this ShapeMemoryOptions.
        :type: float
        """
        self._max_in_gbs = max_in_gbs

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
